## dcm2niix 1.0.20181125

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

if(COMMAND CMAKE_POLICY)
    CMAKE_POLICY(SET CMP0003 NEW)
endif()

project(dcm2niix)

include(${CMAKE_SOURCE_DIR}/SuperBuild/SuperBuild.cmake)

=== console/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

project(console)

# Option Choose whether to use static runtime
include(ucm.cmake)
option(USE_STATIC_RUNTIME "Use static runtime" ON)
if(USE_STATIC_RUNTIME)
    ucm_set_runtime(STATIC)
else()
    ucm_set_runtime(DYNAMIC)
endif()

# Basic CMake build settings
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS  "Debug;Release;RelWithDebInfo;MinSizeRel")
endif()

if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    # using Clang
    add_definitions(-fno-caret-diagnostics)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-dead_strip")
elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    # using GCC
    if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.5.0))
        add_definitions(-Wno-unused-result)    # available since GCC 4.5.0
    endif()
    if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.8.0))
        add_definitions(-fno-diagnostics-show-caret)    # available since GCC 4.8.0
    endif()
elseif(MSVC)
    # using Visual Studio C++
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4018")   # '<': signed/unsigned mismatch
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4068")   # unknown pragma
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4101")   # unreferenced local variable
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4244")   # 'initializing': conversion from 'double' to 'int', possible loss of data
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4267")   # 'initializing': conversion from 'size_t' to 'int', possible loss of data
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4305")   # 'argument': truncation from 'double' to 'float'
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4308")   # negative integral constant converted to unsigned type
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4334")   # '<<': result of 32-bit shift implicitly converted to 64 bits
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4800")   # 'uint32_t' : forcing value to bool 'true' or 'false'
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4819")   # The file contains a character that cannot be represented in the current code page
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4996")   # 'access': The POSIX name for this item is deprecated
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /STACK:8388608")  # set "Stack Reserve Size" to 8MB (default value is 1MB)
endif()

# Compiler dependent flags
include (CheckCXXCompilerFlag)
if(UNIX)
    check_cxx_compiler_flag(-msse2 HAS_SSE2)
    if(HAS_SSE2)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse")
    endif()
endif()

set(PROGRAMS dcm2niix)

set(DCM2NIIX_SRCS
    main_console.cpp
    nii_dicom.cpp
    jpg_0XC3.cpp
    ujpeg.cpp
    nifti1_io_core.cpp
    nii_foreign.cpp
    nii_ortho.cpp
    nii_dicom_batch.cpp)

option(USE_JPEGLS "Build with JPEG-LS support using CharLS" OFF)
if(USE_JPEGLS)
    add_definitions(-DmyEnableJPEGLS)
    if(MSVC)
        add_definitions(-DCHARLS_STATIC)
    endif()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")

    set(CHARLS_SRCS
        charls/jpegls.cpp
        charls/jpegmarkersegment.cpp
        charls/interface.cpp
        charls/jpegstreamwriter.cpp
        charls/jpegstreamreader.cpp)
    add_executable(dcm2niix ${DCM2NIIX_SRCS} ${CHARLS_SRCS})
else()
    add_executable(dcm2niix ${DCM2NIIX_SRCS})
endif()

set(ZLIB_IMPLEMENTATION "Miniz" CACHE STRING "Choose zlib implementation.")
set_property(CACHE ZLIB_IMPLEMENTATION PROPERTY STRINGS  "Miniz;System;Custom")
if(NOT ${ZLIB_IMPLEMENTATION} STREQUAL "Miniz")
    if(NOT ${ZLIB_IMPLEMENTATION} STREQUAL "System")
        set(ZLIB_ROOT ${ZLIB_ROOT} CACHE PATH "Specify custom zlib root directory.")
        if(NOT ZLIB_ROOT)
            message(FATAL_ERROR "ZLIB_ROOT needs to be set to locate custom zlib!")
        endif()
    endif()
    find_package(ZLIB REQUIRED)
    add_definitions(-DmyDisableMiniZ)
    target_include_directories(dcm2niix PRIVATE ${ZLIB_INCLUDE_DIRS})
    target_link_libraries(dcm2niix ${ZLIB_LIBRARIES})
endif()

option(USE_TURBOJPEG "Use TurboJPEG to decode classic JPEG" OFF)
if(USE_TURBOJPEG)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(TURBOJPEG REQUIRED libturbojpeg)
    add_definitions(-DmyTurboJPEG)
    target_include_directories(dcm2niix PRIVATE ${TURBOJPEG_INCLUDEDIR})
    target_link_libraries(dcm2niix ${TURBOJPEG_LIBRARIES})
endif()

option(USE_JASPER "Build with JPEG2000 support using Jasper" OFF)
if(USE_JASPER)
    find_package(Jasper REQUIRED)
    add_definitions(-DmyEnableJasper)
    target_include_directories(dcm2niix PRIVATE ${JASPER_INCLUDE_DIR})
    target_link_libraries(dcm2niix ${JASPER_LIBRARIES})
endif()

option(USE_OPENJPEG "Build with JPEG2000 support using OpenJPEG" OFF)
if(USE_OPENJPEG)
    set(OpenJPEG_DIR "${OpenJPEG_DIR}" CACHE PATH "Path to OpenJPEG configuration file" FORCE)

    find_package(OpenJPEG REQUIRED)

    if(WIN32)
        if(BUILD_SHARED_LIBS)
            add_definitions(-DOPJ_EXPORTS)
        else()
            add_definitions(-DOPJ_STATIC)
        endif()
    endif()

    target_include_directories(dcm2niix PRIVATE ${OPENJPEG_INCLUDE_DIRS})
    target_link_libraries(dcm2niix ${OPENJPEG_LIBRARIES})
else ()
    add_definitions(-DmyDisableOpenJPEG)
endif()

option(BATCH_VERSION "Build dcm2niibatch for multiple conversions" OFF)
if(BATCH_VERSION)
    set(DCM2NIIBATCH_SRCS
        main_console_batch.cpp
        nii_dicom.cpp
        jpg_0XC3.cpp
        ujpeg.cpp
        nifti1_io_core.cpp
        nii_foreign.cpp
        nii_ortho.cpp
        nii_dicom_batch.cpp)

    if(USE_JPEGLS)
        add_executable(dcm2niibatch ${DCM2NIIBATCH_SRCS} ${CHARLS_SRCS})
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
        add_executable(dcm2niibatch ${DCM2NIIBATCH_SRCS})
    endif()

    set(YAML-CPP_DIR ${YAML-CPP_DIR} CACHE PATH "Path to yaml-cpp configuration file" FORCE)

    find_package(YAML-CPP REQUIRED)
    target_include_directories(dcm2niibatch PRIVATE ${YAML_CPP_INCLUDE_DIR})
    target_link_libraries(dcm2niibatch ${YAML_CPP_LIBRARIES})

    if(ZLIB_FOUND)
        target_include_directories(dcm2niibatch PRIVATE ${ZLIB_INCLUDE_DIRS})
        target_link_libraries(dcm2niibatch ${ZLIB_LIBRARIES})
    endif()

    if(TURBOJPEG_FOUND)
        target_include_directories(dcm2niibatch PRIVATE ${TURBOJPEG_INCLUDEDIR})
        target_link_libraries(dcm2niibatch ${TURBOJPEG_LIBRARIES})
    endif()

    if(JASPER_FOUND)
        target_include_directories(dcm2niibatch PRIVATE ${JASPER_INCLUDE_DIR})
        target_link_libraries(dcm2niibatch ${JASPER_LIBRARIES})
    endif()

    if(OPENJPEG_FOUND)
        target_include_directories(dcm2niibatch PRIVATE ${OPENJPEG_INCLUDE_DIRS})
        target_link_libraries(dcm2niibatch ${OPENJPEG_LIBRARIES})
    endif()

    list(APPEND PROGRAMS dcm2niibatch)
endif()

install(TARGETS ${PROGRAMS} DESTINATION bin)

=== debian/changelog ===
dcm2niix (1:1.0.20181125-1~nd1~nd16.04+1) xenial; urgency=medium

  * Backported for xenial.
  * Applied additional patch from debian/patches/xenial-dsc-patch.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Tue, 04 Dec 2018 10:01:42 -0500

dcm2niix (1:1.0.20181125-1~nd1) neurodebian; urgency=medium

  * Fresh upstream release with many fixes and enhancements
  * debian/copyright
    - updated years, removed unused Apache 2.0, and included a few
      entries based on info in Debian-Med packaging
  * debian/patches
    - removed -dsc-patch for elderly EOLed Ubuntu releases
  * debian/control
    - fix Vcs- fields to point to https://github.com/neurodebian/dcm2niix
  * debian/{rules,run_tests}
    - run tests under all dcm_qa* directories now
    - use host_arch "internal" variable instead of DEB_HOST_ARCH
  * debian/source/lintian-overrides
    - do not warn about *-dsc-patch files not be included in series
    - do not complain about public-domain in copyright since it is a
      known keyword

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 03 Dec 2018 15:56:05 -0500

dcm2niix (1:1.0.20180622-1) neurodebian; urgency=medium

  * Fresh upstream bugfix release
    - addresses a bug with a small subset of Philips Enhanced DICOM
      DTI datasets

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 27 Jun 2018 22:17:55 -0400

dcm2niix (1:1.0.20180614-1) neurodebian; urgency=medium

  * Fresh upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 18 Jun 2018 08:41:25 +0800

dcm2niix (1:1.0.20180404+git118-g3762cc0-1) UNRELEASED; urgency=medium

  * Fresh upstream pre-release snapshot
  * debian/
    - rules - enable USE_JPEGLS support for JPEG-LS transfer syntax
      (on systems with recent g++)
    - patches/
      - deb_usepkgconfig_find_yaml to use pkgconfig to locate yaml-cpp

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 13 Jun 2018 12:57:38 -0700

dcm2niix (1:1.0.20171215+git34-gb641a58-1) neurodebian; urgency=medium

  * New upstream snapshot
    - addresses some defects/test failures on i386
  * debian/
    - disable openjpeg support - results for JPEG2000 might be inconsistent
      and this is a strategy which was recommended by upstream to mitigate
      failing tests etc.
  * debian/patches/up_pass_CFLAGS_superbuild, debian/rules
    - set C*_FLAGS to -mmmx -msse -msse2 -mfpmath=sse to guarantee the same
      precision on x86 platforms

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 05 Apr 2018 09:21:42 -0400

dcm2niix (1:1.0.20171215+git31-gca911aa-1) UNRELEASED; urgency=medium

  * New upstream snapshot from v1.0.20171215-31
  * debian/
    - gbp.conf - include git submodules into .orig.tar.gz (dcm_qa)
    - run tests under dcm_qa using built dcm2niix

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 02 Apr 2018 19:24:25 -0400

dcm2niix (1:1.0.20171215+git8-g82b9210-1) neurodebian; urgency=medium

  * Fresh upstream snapshot

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 23 Jan 2018 23:40:39 -0500

=== debian/control ===
Source: dcm2niix
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Michael Hanke <mih@debian.org>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9~),
               cmake,
               pkg-config,
               libboost-dev,
               libyaml-cpp-dev,
               zlib1g-dev
Standards-Version: 4.1.3
Vcs-Browser: https://github.com/neurodebian/dcm2niix
Vcs-Git: https://github.com/neurodebian/dcm2niix
Homepage: https://github.com/rordenlab/dcm2niix

Package: dcm2niix
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends},
         ${misc:Depends}
Description: converts DICOM and PAR/REC files into the NIfTI format
 This is the successor of the well-known dcm2nii program. it aims to provide
 same functionality albeit with much faster operation.
 This is a new tool that is not yet well tested, and does not handle ancient
 proprietary formats. Use with care.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
upstreamver = $(shell echo $(debver) | cut -d '-' -f 1,1 )

# this figures out the last merge point from 'master' into the Debian branch and
# then described this commit relative to the last release tag (release/...)
# If this should make any sense the local upstream branch must track upstream's
# master or whatever other source branch.
gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'v[0-9].[0-9]*.[0-9]*' $$(git merge-base -a HEAD master) | sed -e 's,^v,,' -e 's/-/+git/')

export DH_VERBOSE = 1

hostarch=$(shell dpkg-architecture -qDEB_HOST_ARCH)
# guarantee the same precision on x86 platforms for tests
ifneq (,$(findstring z$(hostarch)z,zamd64z zi386z))
    CFLAGS+=-mmmx -msse -msse2 -mfpmath=sse
endif

# Not exactly sure on where/when it would build, but we see it fail
# on jessie with g++ 4:4.9.2-2
USE_JPEGLS = $(shell dpkg --compare-versions `dpkg -l g++ | awk '/^ii/{print $3;}'` ge 4:4.10 && echo ON || echo OFF)

export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/

# one ring to rule them all ...
%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	g++ --version  # Just FOI
	dh_auto_configure -- \
	  -DUSE_STATIC_RUNTIME:BOOL=OFF \
	  -DUSE_SYSTEM_TURBOJPEG:BOOL=OFF \
      -DUSE_OPENJPEG:BOOL=OFF \
	  -DUSE_SYSTEM_ZLIB:BOOL=ON \
	  -DUSE_JPEGLS:BOOL=$(USE_JPEGLS) \
	  -DBATCH_VERSION:BOOL=ON \
      -DCMAKE_C_FLAGS:STRING="${CFLAGS}" \
      -DCMAKE_CXX_FLAGS:STRING="${CFLAGS}" \
      -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON


override_dh_auto_install:
	dh_auto_install
	# Run tests using built/installed dcm2niix
	debian/run_tests

override_dh_clean:
	dh_clean
	# remove stuff we don't carry in the upstream tarball
	rm -rf dcm2laz qtGui wxWidgets xcode *.command console/unused dcm_qa*/Out

# make orig tarball from repository content
get-orig-source:
	gbp buildpackage --git-verbose -S

# check that DSC patches still apply
maint-check-dsc-patches:
	@for p in debian/patches/*-dsc-patch; \
		do echo "check $$p"; \
		patch -p1 --dry-run < $$p || exit 1 ; \
	done

## dcm2niix 1.0.20190902

=== debian/changelog ===
dcm2niix (1:1.0.20190902-1~nd18.10+1) cosmic; urgency=medium

  * Backported for cosmic.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Mon, 21 Oct 2019 10:41:30 -0400

dcm2niix (1:1.0.20190902-1) neurodebian; urgency=medium

  * New upstream release
  * debian/patches/up_batch_setx - refreshed

 -- Yaroslav Halchenko <debian@onerussian.com>  Sat, 19 Oct 2019 20:19:55 -0400

dcm2niix (1:1.0.20190720-1) neurodebian; urgency=medium

  * Fresh stable upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 23 Aug 2019 10:23:20 -0400

dcm2niix (1:1.0.20190410-1~nd1) neurodebian; urgency=medium

  * Fresh upstream release
    - more testing datasets (dcm_qa*) - might want to start excluding them
      from source tarball and relying on fetching during (neurodebian)
      package build time

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 26 Apr 2019 16:05:44 -0400

dcm2niix (1:1.0.20181125-1~nd2) neurodebian; urgency=medium

  * Enable OpenJPEG back (on amd64 only) as we ran into the case with
    JPEG2000 images which otherwise cannot be handled.  On i386 it
    still segfaults during tests so openjpeg is enabled only on amd64

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 28 Jan 2019 11:40:24 -0500

## dcm2niix 1.0.20200331

=== debian/changelog ===
dcm2niix (1.0.20200331-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Nilesh Patra <npatra974@gmail.com>  Tue, 29 Sep 2020 18:05:29 +0530

dcm2niix (1.0.20181125-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper 12
  * Standards-Version: 4.3.0

 -- Andreas Tille <tille@debian.org>  Wed, 30 Jan 2019 10:37:36 +0100

## dcm2niix 1.0.20201102

=== console/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,9 @@
     set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-dead_strip")
 elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
     # using GCC
+    if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 7.1.0))
+        add_definitions(-Wno-format-overflow)    # available since GCC 7.1.0
+    endif()
     if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 4.5.0))
         add_definitions(-Wno-unused-result)    # available since GCC 4.5.0
     endif()
@@ -187,4 +190,15 @@
     list(APPEND PROGRAMS dcm2niibatch)
 endif()
 
+
+if(APPLE)
+    message("--   Adding Apple plist")
+    set_target_properties(dcm2niix PROPERTIES LINK_FLAGS "-Wl,-sectcreate,__TEXT,__info_plist,${CMAKE_SOURCE_DIR}/Info.plist")
+    #Apple notarization requires a Info.plist
+    # For .app bundles, the Info.plist is a separate file, for executables it is appended as a section
+    #you can check that the Info.plist section has been inserted with either of these commands
+    # otool -l ./dcm2niix | grep info_plist -B1 -A10
+    # launchctl plist ./dcm2niix
+endif()
+
 install(TARGETS ${PROGRAMS} DESTINATION bin)

=== debian/changelog ===
dcm2niix (1.0.20201102-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Nilesh Patra <npatra974@gmail.com>  Fri, 13 Nov 2020 13:38:20 +0530

=== debian/control ===
Source: dcm2niix
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libopenjp2-7-dev,
               libturbojpeg0-dev,
               libyaml-cpp-dev,
               pkg-config,
               python3-sphinx,
               zlib1g-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/dcm2niix
Vcs-Git: https://salsa.debian.org/med-team/dcm2niix.git
Homepage: https://github.com/rordenlab/dcm2niix
Rules-Requires-Root: no

Package: dcm2niix
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: pigz
Description: next generation DICOM to NIfTI converter
 dcm2niix is the successor of dcm2nii, a popular tool for converting images
 from the complicated formats used by scanner manufacturers (DICOM, PAR/REC)
 to the simpler NIfTI format used by many scientific tools. It works for all
 modalities (CT, MRI, PET, SPECT) and sequence types.

## dcm2niix 1.0.20211006

=== console/CMakeLists.txt ===
--- 
+++ 
@@ -53,10 +53,15 @@
 # Compiler dependent flags
 include (CheckCXXCompilerFlag)
 if(UNIX)
-    check_cxx_compiler_flag(-msse2 HAS_SSE2)
-    if(HAS_SSE2)
-        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse")
-    endif()
+    check_cxx_compiler_flag(-march=armv8-a+crc ARM_CRC)
+    if(ARM_CRC)
+        # wrong answer for Apple Silicon: check_cxx_compiler_flag(-msse2 HAS_SSE2)
+    else()
+	    check_cxx_compiler_flag(-msse2 HAS_SSE2)
+	    if(HAS_SSE2)
+	        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse2 -mfpmath=sse")
+	    endif()
+	endif()
 endif()
 
 set(PROGRAMS dcm2niix)

=== debian/changelog ===
dcm2niix (1:1.0.20211006-1~nd21.04+1) hirsute; urgency=medium

  * Backported for hirsute.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Fri, 08 Oct 2021 15:03:06 -0400

dcm2niix (1:1.0.20211006-1) neurodebian; urgency=medium

  * Fresh upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 08 Oct 2021 13:53:28 -0400

dcm2niix (1.0.20210317+git207-g66a4fd0-1) neurodebian-devel; urgency=medium

  * New upstream snapshot from v1.0.20200427-207-g66a4fd0 at
    v1.0.20200427-207-g66a4fd0
    - since it is just a devel stage, regression tests are doomed to fail,
      thus failure is ignored

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 19 Aug 2021 14:07:25 -0400

dcm2niix (1:1.0.20210317-1) neurodebian; urgency=medium

  * Fresh upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 06 Apr 2021 08:37:28 -0400

dcm2niix (1.0.20201102+git97-g0587941-1) neurodebian-devel; urgency=medium

  * New upstream snapshot from v1.0.20200427-97-g0587941 at
    v1.0.20200427-97-g0587941

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 23 Dec 2020 13:15:59 -0500

dcm2niix (1:1.0.20201102-1) neurodebian; urgency=medium

  * Recent upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 08 Dec 2020 18:08:10 -0500

dcm2niix (1:1.0.20200427-1) neurodebian; urgency=medium

  * Fresh non-official release from development branch, which should
    address regression of having some functional scans from Philips
    being split into multiple files. See https://github.com/rordenlab/dcm2niix/issues/395

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 29 Apr 2020 22:45:10 -0400

dcm2niix (1:1.0.20200331-1) neurodebian; urgency=medium

  * New upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 16 Apr 2020 15:39:11 -0400

=== debian/control ===
Source: dcm2niix
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Michael Hanke <mih@debian.org>,
           Yaroslav Halchenko <debian@onerussian.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9~),
               cmake,
               pkg-config,
               libboost-dev,
               libturbojpeg0-dev,
               libopenjp2-7-dev,
               libyaml-cpp-dev,
               zlib1g-dev
Standards-Version: 4.1.3
Vcs-Browser: https://github.com/neurodebian/dcm2niix
Vcs-Git: https://github.com/neurodebian/dcm2niix
Homepage: https://github.com/rordenlab/dcm2niix

Package: dcm2niix
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends},
         ${misc:Depends}
Description: converts DICOM and PAR/REC files into the NIfTI format
 This is the successor of the well-known dcm2nii program. it aims to provide
 same functionality albeit with much faster operation.
 This is a new tool that is not yet well tested, and does not handle ancient
 proprietary formats. Use with care.

=== debian/rules ===
--- 
+++ 
@@ -19,6 +19,9 @@
     CFLAGS+=-mmmx -msse -msse2 -mfpmath=sse
 endif
 
+# On non-amd64 tests segfault with openjpeg, so we enable it only on amd64
+USE_OPENJPEG=$(shell dpkg --print-architecture | grep -q amd64 && echo ON || echo OFF)
+
 # Not exactly sure on where/when it would build, but we see it fail
 # on jessie with g++ 4:4.9.2-2
 USE_JPEGLS = $(shell dpkg --compare-versions `dpkg -l g++ | awk '/^ii/{print $3;}'` ge 4:4.10 && echo ON || echo OFF)
@@ -34,8 +37,8 @@
 	g++ --version  # Just FOI
 	dh_auto_configure -- \
 	  -DUSE_STATIC_RUNTIME:BOOL=OFF \
-	  -DUSE_SYSTEM_TURBOJPEG:BOOL=OFF \
-      -DUSE_OPENJPEG:BOOL=OFF \
+	  -DUSE_SYSTEM_TURBOJPEG:BOOL=ON \
+      -DUSE_OPENJPEG:BOOL=$(USE_OPENJPEG) \
 	  -DUSE_SYSTEM_ZLIB:BOOL=ON \
 	  -DUSE_JPEGLS:BOOL=$(USE_JPEGLS) \
 	  -DBATCH_VERSION:BOOL=ON \
@@ -47,7 +50,7 @@
 override_dh_auto_install:
 	dh_auto_install
 	# Run tests using built/installed dcm2niix
-	debian/run_tests
+	debian/run_tests || :
 
 override_dh_clean:
 	dh_clean

## dcm2niix 1.0.20220720

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.11)
+cmake_minimum_required(VERSION 2.8.12)
 
 if(COMMAND CMAKE_POLICY)
     CMAKE_POLICY(SET CMP0003 NEW)

=== console/CMakeLists.txt ===
--- 
+++ 
@@ -66,6 +66,20 @@
 
 set(PROGRAMS dcm2niix)
 
+option(USE_TURBOJPEG "Use TurboJPEG to decode classic JPEG" OFF)
+option(USE_JASPER "Build with JPEG2000 support using Jasper" OFF)
+option(USE_OPENJPEG "Build with JPEG2000 support using OpenJPEG" OFF)
+option(USE_JPEGLS "Build with JPEG-LS support using CharLS" OFF)
+
+option(BATCH_VERSION "Build dcm2niibatch for multiple conversions" OFF)
+
+option(BUILD_DCM2NIIXFSLIB "Build libdcm2niixfs.a" OFF)
+
+if(USE_OPENJPEG OR USE_TURBOJPEG OR USE_JASPER)
+    message("-- Set BUILD_DCM2NIIXFSLIB to OFF since USE_TURBOJPEG/USE_JASPER/USE_OPENJPEG is ON.")
+    set(BUILD_DCM2NIIXFSLIB OFF CACHE BOOL "Build libdcm2niixfs.a" FORCE)
+endif()
+
 set(DCM2NIIX_SRCS
     main_console.cpp
     nii_dicom.cpp
@@ -76,7 +90,26 @@
     nii_ortho.cpp
     nii_dicom_batch.cpp)
 
-option(USE_JPEGLS "Build with JPEG-LS support using CharLS" OFF)
+
+option(USE_JNIfTI "Build with JNIfTI support" ON)
+if(USE_JNIFTI)
+    add_definitions(-DmyEnableJNIfTI)
+    set(DCM2NIIX_SRCS ${DCM2NIIX_SRCS} cJSON.cpp base64.cpp)
+endif()
+
+if(BUILD_DCM2NIIXFSLIB)
+    set(DCM2NIIXFSLIB dcm2niixfs)
+    set(DCM2NIIXFSLIB_SRCS
+        dcm2niix_fswrapper.cpp
+        nii_dicom.cpp
+        jpg_0XC3.cpp
+        ujpeg.cpp
+        nifti1_io_core.cpp
+        nii_foreign.cpp
+        nii_ortho.cpp
+        nii_dicom_batch.cpp)
+endif()
+
 if(USE_JPEGLS)
     add_definitions(-DmyEnableJPEGLS)
     if(MSVC)
@@ -91,8 +124,16 @@
         charls/jpegstreamwriter.cpp
         charls/jpegstreamreader.cpp)
     add_executable(dcm2niix ${DCM2NIIX_SRCS} ${CHARLS_SRCS})
+
+    if(BUILD_DCM2NIIXFSLIB)
+        add_library(${DCM2NIIXFSLIB} STATIC ${DCM2NIIXFSLIB_SRCS} ${CHARLS_SRCS})
+    endif()
 else()
     add_executable(dcm2niix ${DCM2NIIX_SRCS})
+
+    if(BUILD_DCM2NIIXFSLIB)
+        add_library(${DCM2NIIXFSLIB} STATIC ${DCM2NIIXFSLIB_SRCS})
+    endif()
 endif()
 
 set(ZLIB_IMPLEMENTATION "Miniz" CACHE STRING "Choose zlib implementation.")
@@ -110,7 +151,6 @@
     target_link_libraries(dcm2niix ${ZLIB_LIBRARIES})
 endif()
 
-option(USE_TURBOJPEG "Use TurboJPEG to decode classic JPEG" OFF)
 if(USE_TURBOJPEG)
     find_package(PkgConfig REQUIRED)
     pkg_check_modules(TURBOJPEG REQUIRED libturbojpeg)
@@ -119,7 +159,6 @@
     target_link_libraries(dcm2niix ${TURBOJPEG_LIBRARIES})
 endif()
 
-option(USE_JASPER "Build with JPEG2000 support using Jasper" OFF)
 if(USE_JASPER)
     find_package(Jasper REQUIRED)
     add_definitions(-DmyEnableJasper)
@@ -127,7 +166,6 @@
     target_link_libraries(dcm2niix ${JASPER_LIBRARIES})
 endif()
 
-option(USE_OPENJPEG "Build with JPEG2000 support using OpenJPEG" OFF)
 if(USE_OPENJPEG)
     set(OpenJPEG_DIR "${OpenJPEG_DIR}" CACHE PATH "Path to OpenJPEG configuration file" FORCE)
 
@@ -147,7 +185,6 @@
     add_definitions(-DmyDisableOpenJPEG)
 endif()
 
-option(BATCH_VERSION "Build dcm2niibatch for multiple conversions" OFF)
 if(BATCH_VERSION)
     set(DCM2NIIBATCH_SRCS
         main_console_batch.cpp
@@ -159,6 +196,10 @@
         nii_ortho.cpp
         nii_dicom_batch.cpp)
 
+    if(USE_JNIFTI)
+        set(DCM2NIIBATCH_SRCS ${DCM2NIIBATCH_SRCS} cJSON.cpp base64.cpp)
+    endif()
+
     if(USE_JPEGLS)
         add_executable(dcm2niibatch ${DCM2NIIBATCH_SRCS} ${CHARLS_SRCS})
     else()
@@ -195,6 +236,9 @@
     list(APPEND PROGRAMS dcm2niibatch)
 endif()
 
+if(BUILD_DCM2NIIXFSLIB)
+    target_compile_definitions(${DCM2NIIXFSLIB} PRIVATE -DUSING_DCM2NIIXFSWRAPPER -DUSING_MGH_NIFTI_IO)
+endif()
 
 if(APPLE)
     message("--   Adding Apple plist")
@@ -207,3 +251,7 @@
 endif()
 
 install(TARGETS ${PROGRAMS} DESTINATION bin)
+
+if(BUILD_DCM2NIIXFSLIB)
+    install(TARGETS ${DCM2NIIXFSLIB} DESTINATION lib)
+endif()

=== debian/changelog ===
dcm2niix (1.0.20220720-1build1) mantic; urgency=medium

  * Rebuild against new libyaml-cpp0.8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 02 Sep 2023 07:18:24 +0200

dcm2niix (1.0.20220720-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version

  [ Mohammed Bilal ]
  * Fix hashsum mismatch for autopkgtest

 -- Mohammed Bilal <mdbilal@disroot.org>  Fri, 12 Aug 2022 20:51:12 +0530

dcm2niix (1.0.20211006-5) unstable; urgency=medium

  * Team upload.
  * Fix s390 autopkgtest failure (Closes: #1012336)

 -- Mohammed Bilal <mdbilal@disroot.org>  Wed, 20 Jul 2022 07:56:24 +0530

dcm2niix (1.0.20211006-4) unstable; urgency=medium

  * Team upload.
  * Source-only upload

 -- Andreas Tille <tille@debian.org>  Mon, 23 May 2022 20:43:01 +0200

dcm2niix (1.0.20211006-3) unstable; urgency=medium

  * Team upload.
  * Add autopkgtests
  * Install examples
  * Bump Standards-Version to 4.6.1 (no changes needed)
  * Remove test data & use multi-orig tarball instead
  * Add script to fetch test data
  * New upstream version 1.0.20211006
  * d/t/: Update tests
  * Add copyright for test data

 -- Mohammed Bilal <mdbilal@disroot.org>  Mon, 23 May 2022 15:23:34 +0530

dcm2niix (1.0.20211006-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Team upload.
  * Fix FTCBFS: Annotate python3-sphinx build dependency with :native.
    (Closes: #1010532)

 -- Andreas Tille <tille@debian.org>  Tue, 03 May 2022 21:28:51 +0200

dcm2niix (1.0.20211006-1) unstable; urgency=medium

  * Team upload
  * New upstream version 1.0.20211006
  * Update copyright metadata
  * Promote pigz to Recommends
  * Raise standards version to 4.6.0

 -- Ghislain Vaillant <ghisvail@gmail.com>  Sun, 10 Oct 2021 21:33:59 +0200

dcm2niix (1.0.20210317-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 15 Aug 2021 18:16:00 +0530

=== debian/control ===
Source: dcm2niix
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libopenjp2-7-dev,
               libturbojpeg0-dev,
               libyaml-cpp-dev,
               pkg-config,
               python3-sphinx:native,
               zlib1g-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/dcm2niix
Vcs-Git: https://salsa.debian.org/med-team/dcm2niix.git
Homepage: https://github.com/rordenlab/dcm2niix
Rules-Requires-Root: no

Package: dcm2niix
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: pigz
Description: next generation DICOM to NIfTI converter
 dcm2niix is the successor of dcm2nii, a popular tool for converting images
 from the complicated formats used by scanner manufacturers (DICOM, PAR/REC)
 to the simpler NIfTI format used by many scientific tools. It works for all
 modalities (CT, MRI, PET, SPECT) and sequence types.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic

%:
	dh $@ --sourcedirectory=console --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -rf build/man

override_dh_auto_configure:
	dh_auto_configure -- -DBATCH_VERSION=ON \
		-DUSE_STATIC_RUNTIME=OFF \
		-DUSE_SYSTEM_ZLIB=ON \
		-DUSE_OPENJPEG=ON \
		-DUSE_TURBOJPEG=ON

override_dh_auto_build:
	dh_auto_build
	sphinx-build -N -b man docs/source build/man

override_dh_installchangelogs:
	dh_installchangelogs VERSIONS.md

## dcm2niix 1.0.20240202

=== console/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
     # using Clang
     add_definitions(-fno-caret-diagnostics)
-    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-dead_strip")
+    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-dead_strip -Wl,-stack_size -Wl,0x1000000")
 elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
     # using GCC
     if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 7.1.0))
@@ -47,7 +47,7 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4800")   # 'uint32_t' : forcing value to bool 'true' or 'false'
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4819")   # The file contains a character that cannot be represented in the current code page
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4996")   # 'access': The POSIX name for this item is deprecated
-    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /STACK:8388608")  # set "Stack Reserve Size" to 8MB (default value is 1MB)
+    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /STACK:16388608")  # set "Stack Reserve Size" to 16MB (default value is 1MB)
 endif()
 
 # Compiler dependent flags
@@ -91,9 +91,9 @@
     nii_dicom_batch.cpp)
 
 
-option(USE_JNIfTI "Build with JNIfTI support" ON)
+option(USE_JNIFTI "Build with JNIfTI support" ON)
 if(USE_JNIFTI)
-    add_definitions(-DmyEnableJNIfTI)
+    add_definitions(-DmyEnableJNIFTI)
     set(DCM2NIIX_SRCS ${DCM2NIIX_SRCS} cJSON.cpp base64.cpp)
 endif()
 
@@ -114,8 +114,9 @@
     add_definitions(-DmyEnableJPEGLS)
     if(MSVC)
         add_definitions(-DCHARLS_STATIC)
-    endif()
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
+    else()
+        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
+    endif()
 
     set(CHARLS_SRCS
         charls/jpegls.cpp
@@ -210,6 +211,10 @@
     set(YAML-CPP_DIR ${YAML-CPP_DIR} CACHE PATH "Path to yaml-cpp configuration file" FORCE)
 
     find_package(YAML-CPP REQUIRED)
+    if(YAML-CPP_FOUND AND NOT YAML_CPP_LIBRARIES)
+        # workaround for yaml-cpp-devel-0.7.0-1.fc38 on Fedora Rawhide
+        set(YAML_CPP_LIBRARIES yaml-cpp)
+    endif()
     target_include_directories(dcm2niibatch PRIVATE ${YAML_CPP_INCLUDE_DIR})
     target_link_libraries(dcm2niibatch ${YAML_CPP_LIBRARIES})

=== debian/changelog ===
dcm2niix (1:1.0.20240202-1~nd+1) sid; urgency=medium

  * Backported for sid.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Thu, 25 Apr 2024 17:52:13 -0400

dcm2niix (1:1.0.20240202-1) neurodebian; urgency=medium

  * Recentish upstream release
  * debian/patches: updated and one dropped (upstreamed)
  * debian/rules:
    - updated cmake invocation to point to System versions of the libraries

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 25 Apr 2024 16:30:07 -0400

dcm2niix (1:1.0.20220720-1) neurodebian; urgency=medium

  * Fresh upstream release. Patches refreshed

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 09 Aug 2022 15:58:27 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
upstreamver = $(shell echo $(debver) | cut -d '-' -f 1,1 )

# this figures out the last merge point from 'master' into the Debian branch and
# then described this commit relative to the last release tag (release/...)
# If this should make any sense the local upstream branch must track upstream's
# master or whatever other source branch.
gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'v[0-9].[0-9]*.[0-9]*' $$(git merge-base -a HEAD master) | sed -e 's,^v,,' -e 's/-/+git/')

export DH_VERBOSE = 1

hostarch=$(shell dpkg-architecture -qDEB_HOST_ARCH)
# guarantee the same precision on x86 platforms for tests
ifneq (,$(findstring z$(hostarch)z,zamd64z zi386z))
    CFLAGS+=-mmmx -msse -msse2 -mfpmath=sse
endif

# On non-amd64 tests segfault with openjpeg, so we enable it only on amd64
USE_OPENJPEG=$(shell dpkg --print-architecture | grep -q amd64 && echo System || echo OFF)

# Not exactly sure on where/when it would build, but we see it fail
# on jessie with g++ 4:4.9.2-2
USE_JPEGLS = $(shell dpkg --compare-versions `dpkg -l g++ | awk '/^ii/{print $3;}'` ge 4:4.10 && echo ON || echo OFF)

export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/

# one ring to rule them all ...
%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	g++ --version  # Just FOI
	dh_auto_configure -- \
	  -DUSE_STATIC_RUNTIME:BOOL=OFF \
	  -DUSE_SYSTEM_TURBOJPEG:BOOL=ON \
      -DUSE_OPENJPEG=$(USE_OPENJPEG) \
      -DYAML-CPP_IMPLEMENTATION=System \
	  -DUSE_SYSTEM_ZLIB:BOOL=ON \
	  -DUSE_JPEGLS:BOOL=$(USE_JPEGLS) \
	  -DBATCH_VERSION:BOOL=ON \
      -DCMAKE_C_FLAGS:STRING="${CFLAGS}" \
      -DCMAKE_CXX_FLAGS:STRING="${CFLAGS}" \
      -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON


override_dh_auto_install:
	dh_auto_install
	# Run tests using built/installed dcm2niix
	debian/run_tests || :

override_dh_clean:
	dh_clean
	# remove stuff we don't carry in the upstream tarball
	rm -rf dcm2laz qtGui wxWidgets xcode *.command console/unused dcm_qa*/Out

# make orig tarball from repository content
get-orig-source:
	gbp buildpackage --git-verbose -S

# check that DSC patches still apply
maint-check-dsc-patches:
	@for p in debian/patches/*-dsc-patch; \
		do echo "check $$p"; \
		patch -p1 --dry-run < $$p || exit 1 ; \
	done

## dcm2niix 1.0.20241211

=== console/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.11)
+cmake_minimum_required(VERSION 3.5)
 
 project(console)
 
@@ -21,7 +21,9 @@
 if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
     # using Clang
     add_definitions(-fno-caret-diagnostics)
-    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-dead_strip -Wl,-stack_size -Wl,0x1000000")
+    # issue867 reduce stack pressure
+    # set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-dead_strip -Wl,-stack_size -Wl,0x1000000")
+    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-dead_strip")
 elseif(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
     # using GCC
     if(NOT (${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 7.1.0))

=== debian/changelog ===
dcm2niix (1.0.20241211-1) unstable; urgency=medium

  * New upstream version 1.0.20241211
  * d/control: indicate that architecture-is-little-endian.
  * d/t/get-test-data: add checks to compensate fragile implementation.
  * d/README.source: new: document import of debian-test-data.
  * d/control: declare compliance to standards version 4.7.1.
  * d/t/run-unit-test: update control sums to match new reference results.

 -- Étienne Mollier <emollier@debian.org>  Tue, 25 Feb 2025 21:18:28 +0100

dcm2niix (1.0.20240202-1) unstable; urgency=medium

  * New upstream version 1.0.20240202 fixes: CVE-2024-27629 (Closes: #1074534)
  * d/t/get-test-data: fix multiple issues in the download script.
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.
  * d/t/run-unit-test: freshen expected test result to newer algorithms.
  * d/control: migrate from pkg-config to pkgconf.

 -- Étienne Mollier <emollier@debian.org>  Tue, 06 Aug 2024 14:17:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,19 @@
 Source: dcm2niix
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
+Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: cmake,
                debhelper-compat (= 13),
+               architecture-is-little-endian,
                libopenjp2-7-dev,
                libturbojpeg0-dev,
                libyaml-cpp-dev,
-               pkg-config,
+               pkgconf,
                python3-sphinx:native,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.1
 Vcs-Browser: https://salsa.debian.org/med-team/dcm2niix
 Vcs-Git: https://salsa.debian.org/med-team/dcm2niix.git
 Homepage: https://github.com/rordenlab/dcm2niix

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v@ANY_VERSION@\.tar\.gz/dcm2niix-$1\.tar\.gz/ \
https://github.com/rordenlab/dcm2niix/tags .*/v@ANY_VERSION@\.tar\.gz

## dcm2niix 1.0.20250506

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.5)
 
 if(COMMAND CMAKE_POLICY)
     CMAKE_POLICY(SET CMP0003 NEW)

=== console/CMakeLists.txt ===
--- 
+++ 
@@ -160,6 +160,8 @@
     add_definitions(-DmyTurboJPEG)
     target_include_directories(dcm2niix PRIVATE ${TURBOJPEG_INCLUDEDIR})
     target_link_libraries(dcm2niix ${TURBOJPEG_LIBRARIES})
+    # macOS kludge: pkg-config gives -lturbojpeg, but Homebrew installs libturbojpeg.dylib
+    # target_link_libraries(dcm2niix ${TURBOJPEG_LDFLAGS} turbojpeg)
 endif()
 
 if(USE_JASPER)

=== docs/CMakeLists.txt ===
# Copyright 2016, The dcm2niix contributors
#
# This program is free software: you can redistribute it and/or modify it under
# the terms of the new BSD license. See the license.txt file or visit
# https://opensource.org/licenses/BSD-3-Clause for details.

find_program(SPHINX_EXECUTABLE
        NAMES sphinx-build
        HINTS $ENV{SPHINX_DIR}
        PATH_SUFFIXES bin
        DOC "Sphinx documentation generator")

if (NOT SPHINX_EXECUTABLE)
        message(FATAL_ERROR "sphinx-build executable not found")
endif ()

set(SPHINX_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/source")
set(SPHINX_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/build")
set(SPHINX_CACHE_DIR "${CMAKE_CURRENT_BINARY_DIR}/doctrees")
set(SPHINX_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/man")

configure_file("${SPHINX_SOURCE_DIR}/conf.py"
        "${SPHINX_BUILD_DIR}/conf.py"
        COPYONLY)

add_custom_target(build-man ALL
        COMMAND ${SPHINX_EXECUTABLE}
                -b man
                -c "${SPHINX_BUILD_DIR}"
                -d "${SPHINX_CACHE_DIR}"
                "${SPHINX_SOURCE_DIR}"
                "${SPHINX_OUTPUT_DIR}"
        COMMENT "Generating man pages with Sphinx")

install(DIRECTORY "${SPHINX_OUTPUT_DIR}/"
        DESTINATION "share/man/man1")

=== debian/changelog ===
dcm2niix (1.0.20250506-1) unstable; urgency=medium

  * Team upload.
  * Fix Build with CMake 4
    Closes: #1112830
  * d/watch: version=5
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 17 Oct 2025 11:29:53 +0200

=== debian/control ===
Source: dcm2niix
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Ghislain Antony Vaillant <ghisvail@gmail.com>,
 Étienne Mollier <emollier@debian.org>,
Section: science
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 architecture-is-little-endian,
 libopenjp2-7-dev,
 libturbojpeg0-dev,
 libyaml-cpp-dev,
 pkgconf,
 python3-sphinx:native,
 zlib1g-dev,
Vcs-Browser: https://salsa.debian.org/med-team/dcm2niix
Vcs-Git: https://salsa.debian.org/med-team/dcm2niix.git
Homepage: https://github.com/rordenlab/dcm2niix
Rules-Requires-Root: no

Package: dcm2niix
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 pigz,
Description: next generation DICOM to NIfTI converter
 dcm2niix is the successor of dcm2nii, a popular tool for converting images
 from the complicated formats used by scanner manufacturers (DICOM, PAR/REC)
 to the simpler NIfTI format used by many scientific tools. It works for all
 modalities (CT, MRI, PET, SPECT) and sequence types.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic

%:
	dh $@ --sourcedirectory=console --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -rf build/man

override_dh_auto_configure:
	dh_auto_configure -- -DBATCH_VERSION=ON \
		-DUSE_STATIC_RUNTIME=OFF \
		-DUSE_SYSTEM_ZLIB=ON \
		-DUSE_OPENJPEG=ON \
		-DUSE_TURBOJPEG=ON \
		-DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_auto_build:
	dh_auto_build
	sphinx-build -N -b man docs/source build/man

override_dh_installchangelogs:
	dh_installchangelogs VERSIONS.md

=== debian/watch ===
Version: 5

Template: Github
Owner: rordenlab
Project: dcm2niix
Uversion-Mangle: s/20160606/1.0.20160606/

## dcm2niix 20160921+git16

=== CMakeLists.txt ===
project(dcm2niix)
cmake_minimum_required(VERSION 2.6)

# Option1: Choose whether to build the batch version
option(BATCH_VERSION "Build dcm2niibatch for multiple conversions as well" OFF)
message(${BATCH_VERSION})

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/bin")

#
# Zlib
#
#find_package(ZLIB)

# Predefined permission set to enforce proper permissions
# during install even if files in the sources have different
# settings
set(FILE_PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

##
## Sub-projects
##
add_subdirectory(console)

=== console/CMakeLists.txt ===
project(console)
set(PROGRAMS dcm2niix)

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    # using Clang
    add_definitions(-dead_strip)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    # using GCC
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    # using Intel C++
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    # using Visual Studio C++
endif ()


#We now use miniz, removing zlib dependency
#if(ZLIB_FOUND)
#  TARGET_LINK_LIBRARIES(dcm2niix z)
#else(ZLIB_FOUND)
#  ADD_DEFINITIONS(-DmyDisableZlib)
#endif(ZLIB_FOUND)
add_definitions(-DmyDisableJasper)
add_definitions(-DmyDisableOpenJPEG)

add_executable(dcm2niix
        main_console.cpp
        nii_dicom.cpp
        jpg_0XC3.cpp
        ujpeg.cpp
        nifti1_io_core.cpp
        nii_ortho.cpp
        nii_dicom_batch.cpp)


if (BATCH_VERSION)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

    message("Creating batch version")

    # Resolve system dependency on yaml-cpp, which apparently does not
    # provide a CMake find_package() module.

    # Step 1: Search for library using pkg-config
    find_package(PkgConfig)
    if (PKG_CONFIG_FOUND)
        pkg_check_modules(YAML_CPP yaml-cpp)
        find_path(YAML_CPP_INCLUDE_DIR
                NAMES yaml-cpp
                PATHS ${YAML_CPP_INCLUDE_DIRS})
        find_library(YAML_CPP_LIBRARY
                NAMES yaml-cpp
                PATHS ${YAML_CPP_LIBRARY_DIRS})
    endif ()

    # Step 2: Search for library locally. Only searches for a folder called yaml-cpp
    if (NOT YAML_CPP_LIBRARY)
        message("Checking for yaml-cpp local folder: yaml-cpp")
        if (EXISTS ${CMAKE_SOURCE_DIR}/yaml-cpp)
            message("local version found")
            SET(YAML_CPP_BUILD_TOOLS OFF CACHE BOOL "Build test packages off")
            add_subdirectory(${CMAKE_SOURCE_DIR}/yaml-cpp ${CMAKE_SOURCE_DIR}/yaml-cpp)
            set(YAML_CPP_INCLUDE_DIR ${CMAKE_SOURCE_DIR}/yaml-cpp/include)
        else()
            message("Local version not found")
        endif()
    endif ()

    add_executable(dcm2niibatch
            main_console_batch.cpp
            nii_dicom.cpp
            jpg_0XC3.cpp
            ujpeg.cpp
            nifti1_io_core.cpp
            nii_ortho.cpp
            nii_dicom_batch.cpp)

    target_link_libraries(dcm2niibatch yaml-cpp)

    if (YAML_CPP_INCLUDE_DIR)
        include_directories(${YAML_CPP_INCLUDE_DIR})
    endif ()
endif ()

install(TARGETS ${PROGRAMS} DESTINATION bin)
